/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.143 Revision 1.405
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.143 2005/01/26 16:19:12 ka0ttic Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.405 2012/09/28 15:18:04 ulm Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12inherit multilib 5# @ECLASS: eutils.eclass
13ECLASS=eutils 6# @MAINTAINER:
14INHERITED="$INHERITED $ECLASS" 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
15 17
16DEPEND="!bootstrap? ( sys-devel/patch )" 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
17 20
18DESCRIPTION="Based on the ${ECLASS} eclass" 21inherit multilib toolchain-funcs user
19 22
20# Wait for the supplied number of seconds. If no argument is supplied, defaults 23if has "${EAPI:-0}" 0 1 2; then
21# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 24
22# outputting to a terminal, don't wait. For compatability purposes, the argument 25# @FUNCTION: epause
23# must be an integer greater than zero. 26# @USAGE: [seconds]
24# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 27# @DESCRIPTION:
28# Sleep for the specified number of seconds (default of 5 seconds). Useful when
29# printing a message the user should probably be reading and often used in
30# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
31# don't wait at all. Defined in EAPIs 0 1 and 2.
25epause() { 32epause() {
26 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 33 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
27 sleep ${1:-5}
28 fi
29} 34}
30 35
31# Beep the specified number of times (defaults to five). If our output 36# @FUNCTION: ebeep
32# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 37# @USAGE: [number of beeps]
33# don't beep. 38# @DESCRIPTION:
34# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 39# Issue the specified number of beeps (default of 5 beeps). Useful when
40# printing a message the user should probably be reading and often used in
41# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
42# don't beep at all. Defined in EAPIs 0 1 and 2.
35ebeep() { 43ebeep() {
36 local n 44 local n
37 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 45 if [[ -z ${EBEEP_IGNORE} ]] ; then
38 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 46 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
39 echo -ne "\a" 47 echo -ne "\a"
40 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 48 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
41 echo -ne "\a" 49 echo -ne "\a"
42 sleep 1 50 sleep 1
43 done 51 done
44 fi 52 fi
45} 53}
46 54
47# This function generate linker scripts in /usr/lib for dynamic 55else
48# libs in /lib. This is to fix linking problems when you have
49# the .so in /lib, and the .a in /usr/lib. What happens is that
50# in some cases when linking dynamic, the .a in /usr/lib is used
51# instead of the .so in /lib due to gcc/libtool tweaking ld's
52# library search path. This cause many builds to fail.
53# See bug #4411 for more info.
54#
55# To use, simply call:
56#
57# gen_usr_ldscript libfoo.so
58#
59# Note that you should in general use the unversioned name of
60# the library, as ldconfig should usually update it correctly
61# to point to the latest version of the library present.
62#
63# <azarah@gentoo.org> (26 Oct 2002)
64#
65gen_usr_ldscript() {
66 local libdir="$(get_libdir)"
67 # Just make sure it exists
68 dodir /usr/${libdir}
69 56
70 cat > "${D}/usr/${libdir}/${1}" << END_LDSCRIPT 57ebeep() {
71/* GNU ld script 58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
72 Because Gentoo have critical dynamic libraries
73 in /lib, and the static versions in /usr/lib, we
74 need to have a "fake" dynamic lib in /usr/lib,
75 otherwise we run into linking problems.
76 See bug #4411 on http://bugs.gentoo.org/ for
77 more info. */
78GROUP ( /${libdir}/${1} )
79END_LDSCRIPT
80 fperms a+x "/usr/${libdir}/${1}"
81} 59}
82 60
83# Simple function to draw a line consisting of '=' the same length as $* 61epause() {
84# 62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
85# <azarah@gentoo.org> (11 Nov 2002) 63}
86#
87draw_line() {
88 local i=0
89 local str_length=""
90 64
91 # Handle calls that do not have args, or wc not being installed ... 65fi
92 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ] 66
93 then 67# @FUNCTION: eqawarn
94 echo "===============================================================" 68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78fi
79
80# @FUNCTION: ecvs_clean
81# @USAGE: [list of dirs]
82# @DESCRIPTION:
83# Remove CVS directories recursiveley. Useful when a source tarball contains
84# internal CVS directories. Defaults to $PWD.
85ecvs_clean() {
86 [[ -z $* ]] && set -- .
87 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89}
90
91# @FUNCTION: esvn_clean
92# @USAGE: [list of dirs]
93# @DESCRIPTION:
94# Remove .svn directories recursiveley. Useful when a source tarball contains
95# internal Subversion directories. Defaults to $PWD.
96esvn_clean() {
97 [[ -z $* ]] && set -- .
98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99}
100
101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
107#
108# The following code snippet will echo 5, then 4, then 3, then ...
109# @CODE
110# estack_push mystack 1 2 3 4 5
111# while estack_pop mystack i ; do
112# echo "${i}"
113# done
114# @CODE
115estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="__ESTACK_$1__" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
119}
120
121# @FUNCTION: estack_pop
122# @USAGE: <stack> [variable]
123# @DESCRIPTION:
124# Pop a single item off the specified stack. If a variable is specified,
125# the popped item is stored there. If no more items are available, return
126# 1, else return 0. See estack_push for more info.
127estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129
130 # We use the fugly __estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The __estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local __estack_name="__ESTACK_$1__" ; shift
137 local __estack_retvar=$1 ; shift
138 eval local __estack_i=\${#${__estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --__estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${__estack_retvar} ]] ; then
144 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
145 fi
146 eval unset ${__estack_name}\[${__estack_i}\]
147}
148
149# @FUNCTION: eshopts_push
150# @USAGE: [options to `set` or `shopt`]
151# @DESCRIPTION:
152# Often times code will want to enable a shell option to change code behavior.
153# Since changing shell options can easily break other pieces of code (which
154# assume the default state), eshopts_push is used to (1) push the current shell
155# options onto a stack and (2) pass the specified arguments to set.
156#
157# If the first argument is '-s' or '-u', we assume you want to call `shopt`
158# rather than `set` as there are some options only available via that.
159#
160# A common example is to disable shell globbing so that special meaning/care
161# may be used with variables/arguments to custom functions. That would be:
162# @CODE
163# eshopts_push -s noglob
164# for x in ${foo} ; do
165# if ...some check... ; then
166# eshopts_pop
95 return 0 167# return 0
96 fi 168# fi
97
98 # Get the length of $*
99 str_length="$(echo -n "$*" | wc -m)"
100
101 while [ "$i" -lt "${str_length}" ]
102 do
103 echo -n "="
104
105 i=$((i + 1))
106 done 169# done
107 170# eshopts_pop
108 echo 171# @CODE
109 172eshopts_push() {
110 return 0 173 if [[ $1 == -[su] ]] ; then
174 estack_push eshopts "$(shopt -p)"
175 [[ $# -eq 0 ]] && return 0
176 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
177 else
178 estack_push eshopts $-
179 [[ $# -eq 0 ]] && return 0
180 set "$@" || die "${FUNCNAME}: bad options to set: $*"
181 fi
111} 182}
112 183
113# Default directory where patches are located 184# @FUNCTION: eshopts_pop
185# @USAGE:
186# @DESCRIPTION:
187# Restore the shell options to the state saved with the corresponding
188# eshopts_push call. See that function for more details.
189eshopts_pop() {
190 local s
191 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
192 if [[ ${s} == "shopt -"* ]] ; then
193 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
194 else
195 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
196 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
197 fi
198}
199
200# @FUNCTION: eumask_push
201# @USAGE: <new umask>
202# @DESCRIPTION:
203# Set the umask to the new value specified while saving the previous
204# value onto a stack. Useful for temporarily changing the umask.
205eumask_push() {
206 estack_push eumask "$(umask)"
207 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
208}
209
210# @FUNCTION: eumask_pop
211# @USAGE:
212# @DESCRIPTION:
213# Restore the previous umask state.
214eumask_pop() {
215 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
216 local s
217 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
218 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
219}
220
221# @VARIABLE: EPATCH_SOURCE
222# @DESCRIPTION:
223# Default directory to search for patches.
114EPATCH_SOURCE="${WORKDIR}/patch" 224EPATCH_SOURCE="${WORKDIR}/patch"
115# Default extension for patches 225# @VARIABLE: EPATCH_SUFFIX
226# @DESCRIPTION:
227# Default extension for patches (do not prefix the period yourself).
116EPATCH_SUFFIX="patch.bz2" 228EPATCH_SUFFIX="patch.bz2"
117# Default options for patch 229# @VARIABLE: EPATCH_OPTS
118# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 230# @DESCRIPTION:
231# Options to pass to patch. Meant for ebuild/package-specific tweaking
232# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
233# for single patch tweaking, you can also pass flags directly to epatch.
119EPATCH_OPTS="-g0" 234EPATCH_OPTS=""
235# @VARIABLE: EPATCH_COMMON_OPTS
236# @DESCRIPTION:
237# Common options to pass to `patch`. You probably should never need to
238# change these. If you do, please discuss it with base-system first to
239# be sure.
240# @CODE
241# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
242# --no-backup-if-mismatch - do not leave .orig files behind
243# -E - automatically remove empty files
244# @CODE
245EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
246# @VARIABLE: EPATCH_EXCLUDE
247# @DESCRIPTION:
120# List of patches not to apply. Not this is only file names, 248# List of patches not to apply. Note this is only file names,
121# and not the full path .. 249# and not the full path. Globs accepted.
122EPATCH_EXCLUDE="" 250EPATCH_EXCLUDE=""
251# @VARIABLE: EPATCH_SINGLE_MSG
252# @DESCRIPTION:
123# Change the printed message for a single patch. 253# Change the printed message for a single patch.
124EPATCH_SINGLE_MSG="" 254EPATCH_SINGLE_MSG=""
125# Force applying bulk patches even if not following the style: 255# @VARIABLE: EPATCH_MULTI_MSG
126# 256# @DESCRIPTION:
127# ??_${ARCH}_foo.${EPATCH_SUFFIX} 257# Change the printed message for multiple patches.
128# 258EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
259# @VARIABLE: EPATCH_FORCE
260# @DESCRIPTION:
261# Only require patches to match EPATCH_SUFFIX rather than the extended
262# arch naming style.
129EPATCH_FORCE="no" 263EPATCH_FORCE="no"
130 264
131# This function is for bulk patching, or in theory for just one 265# @FUNCTION: epatch
132# or two patches. 266# @USAGE: [options] [patches] [dirs of patches]
267# @DESCRIPTION:
268# epatch is designed to greatly simplify the application of patches. It can
269# process patch files directly, or directories of patches. The patches may be
270# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
271# the -p option as epatch will automatically attempt -p0 to -p5 until things
272# apply successfully.
133# 273#
134# It should work with .bz2, .gz, .zip and plain text patches. 274# If you do not specify any patches/dirs, then epatch will default to the
135# Currently all patches should be the same format. 275# directory specified by EPATCH_SOURCE.
136# 276#
137# You do not have to specify '-p' option to patch, as it will 277# Any options specified that start with a dash will be passed down to patch
138# try with -p0 to -p5 until it succeed, or fail at -p5. 278# for this specific invocation. As soon as an arg w/out a dash is found, then
279# arg processing stops.
139# 280#
140# Above EPATCH_* variables can be used to control various defaults, 281# When processing directories, epatch will apply all patches that match:
141# bug they should be left as is to ensure an ebuild can rely on 282# @CODE
142# them for. 283# if ${EPATCH_FORCE} != "yes"
143#
144# Patches are applied in current directory.
145#
146# Bulk Patches should preferibly have the form of:
147#
148# ??_${ARCH}_foo.${EPATCH_SUFFIX} 284# ??_${ARCH}_foo.${EPATCH_SUFFIX}
285# else
286# *.${EPATCH_SUFFIX}
287# @CODE
288# The leading ?? are typically numbers used to force consistent patch ordering.
289# The arch field is used to apply patches only for the host architecture with
290# the special value of "all" means apply for everyone. Note that using values
291# other than "all" is highly discouraged -- you should apply patches all the
292# time and let architecture details be detected at configure/compile time.
149# 293#
150# For example: 294# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
295# for patches to apply.
151# 296#
152# 01_all_misc-fix.patch.bz2 297# Refer to the other EPATCH_xxx variables for more customization of behavior.
153# 02_sparc_another-fix.patch.bz2
154#
155# This ensures that there are a set order, and you can have ARCH
156# specific patches.
157#
158# If you however give an argument to epatch(), it will treat it as a
159# single patch that need to be applied if its a file. If on the other
160# hand its a directory, it will set EPATCH_SOURCE to this.
161#
162# <azarah@gentoo.org> (10 Nov 2002)
163#
164epatch() { 298epatch() {
165 local PIPE_CMD="" 299 _epatch_draw_line() {
166 local STDERR_TARGET="${T}/$$.out" 300 # create a line of same length as input string
167 local PATCH_TARGET="${T}/$$.patch" 301 [[ -z $1 ]] && set "$(printf "%65s" '')"
168 local PATCH_SUFFIX="" 302 echo "${1//?/=}"
169 local SINGLE_PATCH="no" 303 }
170 local x=""
171 304
172 if [ "$#" -gt 1 ] 305 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
173 then 306
307 # First process options. We localize the EPATCH_OPTS setting
308 # from above so that we can pass it on in the loop below with
309 # any additional values the user has specified.
310 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
311 while [[ $# -gt 0 ]] ; do
312 case $1 in
313 -*) EPATCH_OPTS+=( "$1" ) ;;
314 *) break ;;
315 esac
316 shift
317 done
318
319 # Let the rest of the code process one user arg at a time --
320 # each arg may expand into multiple patches, and each arg may
321 # need to start off with the default global EPATCH_xxx values
322 if [[ $# -gt 1 ]] ; then
174 local m="" 323 local m
175 einfo "${#} patches to apply ..."
176 for m in "$@" ; do 324 for m in "$@" ; do
177 epatch "${m}" 325 epatch "${m}"
178 done 326 done
179 return 0 327 return 0
180 fi 328 fi
181 329
182 if [ -n "$1" -a -f "$1" ] 330 local SINGLE_PATCH="no"
183 then 331 # no args means process ${EPATCH_SOURCE}
332 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
333
334 if [[ -f $1 ]] ; then
184 SINGLE_PATCH="yes" 335 SINGLE_PATCH="yes"
185 336 set -- "$1"
186 local EPATCH_SOURCE="$1" 337 # Use the suffix from the single patch (localize it); the code
338 # below will find the suffix for us
187 local EPATCH_SUFFIX="${1##*\.}" 339 local EPATCH_SUFFIX=$1
188 340
189 elif [ -n "$1" -a -d "$1" ] 341 elif [[ -d $1 ]] ; then
190 then 342 # Some people like to make dirs of patches w/out suffixes (vim)
191 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 343 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
192 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 344
345 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
346 # Re-use EPATCH_SOURCE as a search dir
347 epatch "${EPATCH_SOURCE}/$1"
348 return $?
349
350 else
351 # sanity check ... if it isn't a dir or file, wtf man ?
352 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
353 echo
354 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
355 eerror
356 eerror " ${EPATCH_SOURCE}"
357 eerror " ( ${EPATCH_SOURCE##*/} )"
358 echo
359 die "Cannot find \$EPATCH_SOURCE!"
360 fi
361
362 # Now that we know we're actually going to apply something, merge
363 # all of the patch options back in to a single variable for below.
364 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
365
366 local PIPE_CMD
367 case ${EPATCH_SUFFIX##*\.} in
368 xz) PIPE_CMD="xz -dc" ;;
369 lzma) PIPE_CMD="lzma -dc" ;;
370 bz2) PIPE_CMD="bzip2 -dc" ;;
371 gz|Z|z) PIPE_CMD="gzip -dc" ;;
372 ZIP|zip) PIPE_CMD="unzip -p" ;;
373 *) ;;
374 esac
375
376 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
377
378 local x
379 for x in "$@" ; do
380 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
381 # didn't match anything, ignore continue on
382 [[ ! -f ${x} ]] && continue
383
384 local patchname=${x##*/}
385
386 # Apply single patches, or forced sets of patches, or
387 # patches with ARCH dependant names.
388 # ???_arch_foo.patch
389 # Else, skip this input altogether
390 local a=${patchname#*_} # strip the ???_
391 a=${a%%_*} # strip the _foo.patch
392 if ! [[ ${SINGLE_PATCH} == "yes" || \
393 ${EPATCH_FORCE} == "yes" || \
394 ${a} == all || \
395 ${a} == ${ARCH} ]]
193 then 396 then
194 local EPATCH_SOURCE="$1/*" 397 continue
398 fi
399
400 # Let people filter things dynamically
401 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
402 # let people use globs in the exclude
403 eshopts_push -o noglob
404
405 local ex
406 for ex in ${EPATCH_EXCLUDE} ; do
407 if [[ ${patchname} == ${ex} ]] ; then
408 eshopts_pop
409 continue 2
410 fi
411 done
412
413 eshopts_pop
414 fi
415
416 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
417 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
418 einfo "${EPATCH_SINGLE_MSG}"
419 else
420 einfo "Applying ${patchname} ..."
421 fi
195 else 422 else
196 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 423 einfo " ${patchname} ..."
424 fi
425
426 # most of the time, there will only be one run per unique name,
427 # but if there are more, make sure we get unique log filenames
428 local STDERR_TARGET="${T}/${patchname}.out"
429 if [[ -e ${STDERR_TARGET} ]] ; then
430 STDERR_TARGET="${T}/${patchname}-$$.out"
431 fi
432
433 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
434
435 # Decompress the patch if need be
436 local count=0
437 local PATCH_TARGET
438 if [[ -n ${PIPE_CMD} ]] ; then
439 PATCH_TARGET="${T}/$$.patch"
440 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
441
442 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
443 echo
444 eerror "Could not extract patch!"
445 #die "Could not extract patch!"
446 count=5
447 break
197 fi 448 fi
449 else
450 PATCH_TARGET=${x}
451 fi
452
453 # Check for absolute paths in patches. If sandbox is disabled,
454 # people could (accidently) patch files in the root filesystem.
455 # Or trigger other unpleasantries #237667. So disallow -p0 on
456 # such patches.
457 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
458 if [[ -n ${abs_paths} ]] ; then
459 count=1
460 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
461 fi
462 # Similar reason, but with relative paths.
463 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
464 if [[ -n ${rel_paths} ]] ; then
465 eqawarn "QA Notice: Your patch uses relative paths '../'."
466 eqawarn " In the future this will cause a failure."
467 eqawarn "${rel_paths}"
468 fi
469
470 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
471 local patch_cmd
472 while [[ ${count} -lt 5 ]] ; do
473 patch_cmd="${BASH_ALIASES[patch]:-patch} -p${count} ${EPATCH_OPTS}"
474
475 # Generate some useful debug info ...
476 (
477 _epatch_draw_line "***** ${patchname} *****"
478 echo
479 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
480 echo
481 _epatch_draw_line "***** ${patchname} *****"
482 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
483 ret=$?
484 echo
485 echo "patch program exited with status ${ret}"
486 exit ${ret}
487 ) >> "${STDERR_TARGET}"
488
489 if [ $? -eq 0 ] ; then
490 (
491 _epatch_draw_line "***** ${patchname} *****"
492 echo
493 echo "ACTUALLY APPLYING ${patchname} ..."
494 echo
495 _epatch_draw_line "***** ${patchname} *****"
496 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
497 ret=$?
498 echo
499 echo "patch program exited with status ${ret}"
500 exit ${ret}
501 ) >> "${STDERR_TARGET}"
502
503 if [ $? -ne 0 ] ; then
504 echo
505 eerror "A dry-run of patch command succeeded, but actually"
506 eerror "applying the patch failed!"
507 #die "Real world sux compared to the dreamworld!"
508 count=5
509 fi
510 break
511 fi
512
513 : $(( count++ ))
514 done
515
516 # if we had to decompress the patch, delete the temp one
517 if [[ -n ${PIPE_CMD} ]] ; then
518 rm -f "${PATCH_TARGET}"
519 fi
520
521 if [[ ${count} -ge 5 ]] ; then
522 echo
523 eerror "Failed Patch: ${patchname} !"
524 eerror " ( ${PATCH_TARGET} )"
525 eerror
526 eerror "Include in your bugreport the contents of:"
527 eerror
528 eerror " ${STDERR_TARGET}"
529 echo
530 die "Failed Patch: ${patchname}!"
531 fi
532
533 # if everything worked, delete the full debug patch log
534 rm -f "${STDERR_TARGET}"
535
536 # then log away the exact stuff for people to review later
537 cat <<-EOF >> "${T}/epatch.log"
538 PATCH: ${x}
539 CMD: ${patch_cmd}
540 PWD: ${PWD}
541
542 EOF
543 eend 0
544 done
545
546 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
547 : # everything worked
548}
549
550# @FUNCTION: epatch_user
551# @USAGE:
552# @DESCRIPTION:
553# Applies user-provided patches to the source tree. The patches are
554# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
555# of these three directories to exist will be the one to use, ignoring
556# any more general directories which might exist as well. They must end
557# in ".patch" to be applied.
558#
559# User patches are intended for quick testing of patches without ebuild
560# modifications, as well as for permanent customizations a user might
561# desire. Obviously, there can be no official support for arbitrarily
562# patched ebuilds. So whenever a build log in a bug report mentions that
563# user patches were applied, the user should be asked to reproduce the
564# problem without these.
565#
566# Not all ebuilds do call this function, so placing patches in the
567# stated directory might or might not work, depending on the package and
568# the eclasses it inherits and uses. It is safe to call the function
569# repeatedly, so it is always possible to add a call at the ebuild
570# level. The first call is the time when the patches will be
571# applied.
572#
573# Ideally, this function should be called after gentoo-specific patches
574# have been applied, so that their code can be modified as well, but
575# before calls to e.g. eautoreconf, as the user patches might affect
576# autotool input files as well.
577epatch_user() {
578 [[ $# -ne 0 ]] && die "epatch_user takes no options"
579
580 # Allow multiple calls to this function; ignore all but the first
581 local applied="${T}/epatch_user.log"
582 [[ -e ${applied} ]] && return 2
583
584 # don't clobber any EPATCH vars that the parent might want
585 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
586 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}; do
587 EPATCH_SOURCE=${base}/${CTARGET}/${check}
588 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
589 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
590 if [[ -d ${EPATCH_SOURCE} ]] ; then
591 EPATCH_SOURCE=${EPATCH_SOURCE} \
592 EPATCH_SUFFIX="patch" \
593 EPATCH_FORCE="yes" \
594 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
595 epatch
596 echo "${EPATCH_SOURCE}" > "${applied}"
597 return 0
598 fi
599 done
600 echo "none" > "${applied}"
601 return 1
602}
603
604# @FUNCTION: emktemp
605# @USAGE: [temp dir]
606# @DESCRIPTION:
607# Cheap replacement for when debianutils (and thus mktemp)
608# does not exist on the users system.
609emktemp() {
610 local exe="touch"
611 [[ $1 == -d ]] && exe="mkdir" && shift
612 local topdir=$1
613
614 if [[ -z ${topdir} ]] ; then
615 [[ -z ${T} ]] \
616 && topdir="/tmp" \
617 || topdir=${T}
618 fi
619
620 if ! type -P mktemp > /dev/null ; then
621 # system lacks `mktemp` so we have to fake it
622 local tmp=/
623 while [[ -e ${tmp} ]] ; do
624 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
625 done
626 ${exe} "${tmp}" || ${exe} -p "${tmp}"
627 echo "${tmp}"
198 else 628 else
199 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 629 # the args here will give slightly wierd names on BSD,
200 then 630 # but should produce a usable file on all userlands
201 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 631 if [[ ${exe} == "touch" ]] ; then
202 then 632 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
203 EPATCH_SOURCE="$1" 633 else
634 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
635 fi
636 fi
637}
638
639# @FUNCTION: edos2unix
640# @USAGE: <file> [more files ...]
641# @DESCRIPTION:
642# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
643# to remove all of these text utilities from DEPEND variables because this
644# is a script based solution. Just give it a list of files to convert and
645# they will all be changed from the DOS CRLF format to the UNIX LF format.
646edos2unix() {
647 [[ $# -eq 0 ]] && return 0
648 sed -i 's/\r$//' -- "$@" || die
649}
650
651# @FUNCTION: make_desktop_entry
652# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
653# @DESCRIPTION:
654# Make a .desktop file.
655#
656# @CODE
657# binary: what command does the app run with ?
658# name: the name that will show up in the menu
659# icon: the icon to use in the menu entry
660# this can be relative (to /usr/share/pixmaps) or
661# a full path to an icon
662# type: what kind of application is this?
663# for categories:
664# http://standards.freedesktop.org/menu-spec/latest/apa.html
665# if unset, function tries to guess from package's category
666# fields: extra fields to append to the desktop file; a printf string
667# @CODE
668make_desktop_entry() {
669 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
670
671 local exec=${1}
672 local name=${2:-${PN}}
673 local icon=${3:-${PN}}
674 local type=${4}
675 local fields=${5}
676
677 if [[ -z ${type} ]] ; then
678 local catmaj=${CATEGORY%%-*}
679 local catmin=${CATEGORY##*-}
680 case ${catmaj} in
681 app)
682 case ${catmin} in
683 accessibility) type="Utility;Accessibility";;
684 admin) type=System;;
685 antivirus) type=System;;
686 arch) type="Utility;Archiving";;
687 backup) type="Utility;Archiving";;
688 cdr) type="AudioVideo;DiscBurning";;
689 dicts) type="Office;Dictionary";;
690 doc) type=Documentation;;
691 editors) type="Utility;TextEditor";;
692 emacs) type="Development;TextEditor";;
693 emulation) type="System;Emulator";;
694 laptop) type="Settings;HardwareSettings";;
695 office) type=Office;;
696 pda) type="Office;PDA";;
697 vim) type="Development;TextEditor";;
698 xemacs) type="Development;TextEditor";;
699 esac
700 ;;
701
702 dev)
703 type="Development"
704 ;;
705
706 games)
707 case ${catmin} in
708 action|fps) type=ActionGame;;
709 arcade) type=ArcadeGame;;
710 board) type=BoardGame;;
711 emulation) type=Emulator;;
712 kids) type=KidsGame;;
713 puzzle) type=LogicGame;;
714 roguelike) type=RolePlaying;;
715 rpg) type=RolePlaying;;
716 simulation) type=Simulation;;
717 sports) type=SportsGame;;
718 strategy) type=StrategyGame;;
719 esac
720 type="Game;${type}"
721 ;;
722
723 gnome)
724 type="Gnome;GTK"
725 ;;
726
727 kde)
728 type="KDE;Qt"
729 ;;
730
731 mail)
732 type="Network;Email"
733 ;;
734
735 media)
736 case ${catmin} in
737 gfx)
738 type=Graphics
739 ;;
740 *)
741 case ${catmin} in
742 radio) type=Tuner;;
743 sound) type=Audio;;
744 tv) type=TV;;
745 video) type=Video;;
746 esac
747 type="AudioVideo;${type}"
748 ;;
749 esac
750 ;;
751
752 net)
753 case ${catmin} in
754 dialup) type=Dialup;;
755 ftp) type=FileTransfer;;
756 im) type=InstantMessaging;;
757 irc) type=IRCClient;;
758 mail) type=Email;;
759 news) type=News;;
760 nntp) type=News;;
761 p2p) type=FileTransfer;;
762 voip) type=Telephony;;
763 esac
764 type="Network;${type}"
765 ;;
766
767 sci)
768 case ${catmin} in
769 astro*) type=Astronomy;;
770 bio*) type=Biology;;
771 calc*) type=Calculator;;
772 chem*) type=Chemistry;;
773 elec*) type=Electronics;;
774 geo*) type=Geology;;
775 math*) type=Math;;
776 physics) type=Physics;;
777 visual*) type=DataVisualization;;
778 esac
779 type="Education;Science;${type}"
780 ;;
781
782 sys)
783 type="System"
784 ;;
785
786 www)
787 case ${catmin} in
788 client) type=WebBrowser;;
789 esac
790 type="Network;${type}"
791 ;;
792
793 *)
794 type=
795 ;;
796 esac
797 fi
798 if [ "${SLOT}" == "0" ] ; then
799 local desktop_name="${PN}"
800 else
801 local desktop_name="${PN}-${SLOT}"
802 fi
803 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
804 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
805
806 # Don't append another ";" when a valid category value is provided.
807 type=${type%;}${type:+;}
808
809 eshopts_push -s extglob
810 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
811 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
812 ewarn "allowed in .desktop files if the value is not an absolute path."
813 icon=${icon%.@(xpm|png|svg)}
814 fi
815 eshopts_pop
816
817 cat <<-EOF > "${desktop}"
818 [Desktop Entry]
819 Name=${name}
820 Type=Application
821 Comment=${DESCRIPTION}
822 Exec=${exec}
823 TryExec=${exec%% *}
824 Icon=${icon}
825 Categories=${type}
826 EOF
827
828 if [[ ${fields:-=} != *=* ]] ; then
829 # 5th arg used to be value to Path=
830 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
831 fields="Path=${fields}"
832 fi
833 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
834
835 (
836 # wrap the env here so that the 'insinto' call
837 # doesn't corrupt the env of the caller
838 insinto /usr/share/applications
839 doins "${desktop}"
840 ) || die "installing desktop file failed"
841}
842
843# @FUNCTION: validate_desktop_entries
844# @USAGE: [directories]
845# @MAINTAINER:
846# Carsten Lohrke <carlo@gentoo.org>
847# @DESCRIPTION:
848# Validate desktop entries using desktop-file-utils
849validate_desktop_entries() {
850 if [[ -x /usr/bin/desktop-file-validate ]] ; then
851 einfo "Checking desktop entry validity"
852 local directories=""
853 for d in /usr/share/applications $@ ; do
854 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
855 done
856 if [[ -n ${directories} ]] ; then
857 for FILE in $(find ${directories} -name "*\.desktop" \
858 -not -path '*.hidden*' | sort -u 2>/dev/null)
859 do
860 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
861 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
862 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
863 done
864 fi
865 echo ""
866 else
867 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
868 fi
869}
870
871# @FUNCTION: make_session_desktop
872# @USAGE: <title> <command> [command args...]
873# @DESCRIPTION:
874# Make a GDM/KDM Session file. The title is the file to execute to start the
875# Window Manager. The command is the name of the Window Manager.
876#
877# You can set the name of the file via the ${wm} variable.
878make_session_desktop() {
879 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
880 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
881
882 local title=$1
883 local command=$2
884 local desktop=${T}/${wm:-${PN}}.desktop
885 shift 2
886
887 cat <<-EOF > "${desktop}"
888 [Desktop Entry]
889 Name=${title}
890 Comment=This session logs you into ${title}
891 Exec=${command} $*
892 TryExec=${command}
893 Type=XSession
894 EOF
895
896 (
897 # wrap the env here so that the 'insinto' call
898 # doesn't corrupt the env of the caller
899 insinto /usr/share/xsessions
900 doins "${desktop}"
901 )
902}
903
904# @FUNCTION: domenu
905# @USAGE: <menus>
906# @DESCRIPTION:
907# Install the list of .desktop menu files into the appropriate directory
908# (/usr/share/applications).
909domenu() {
910 (
911 # wrap the env here so that the 'insinto' call
912 # doesn't corrupt the env of the caller
913 local i j ret=0
914 insinto /usr/share/applications
915 for i in "$@" ; do
916 if [[ -f ${i} ]] ; then
917 doins "${i}"
918 ((ret+=$?))
919 elif [[ -d ${i} ]] ; then
920 for j in "${i}"/*.desktop ; do
921 doins "${j}"
922 ((ret+=$?))
923 done
924 else
925 ((++ret))
926 fi
927 done
928 exit ${ret}
929 )
930}
931
932# @FUNCTION: newmenu
933# @USAGE: <menu> <newname>
934# @DESCRIPTION:
935# Like all other new* functions, install the specified menu as newname.
936newmenu() {
937 (
938 # wrap the env here so that the 'insinto' call
939 # doesn't corrupt the env of the caller
940 insinto /usr/share/applications
941 newins "$@"
942 )
943}
944
945# @FUNCTION: _iconins
946# @INTERNAL
947# @DESCRIPTION:
948# function for use in doicon and newicon
949_iconins() {
950 (
951 # wrap the env here so that the 'insinto' call
952 # doesn't corrupt the env of the caller
953 local funcname=$1; shift
954 local size dir
955 local context=apps
956 local theme=hicolor
957
958 while [[ $# -gt 0 ]] ; do
959 case $1 in
960 -s|--size)
961 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
962 size=${2%%x*}
963 else
964 size=${2}
204 fi 965 fi
205 966 case ${size} in
206 echo 967 16|22|24|32|36|48|64|72|96|128|192|256)
207 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 968 size=${size}x${size};;
208 eerror 969 scalable)
209 eerror " ${EPATCH_SOURCE}"
210 eerror " ( ${EPATCH_SOURCE##*/} )"
211 echo
212 die "Cannot find \$EPATCH_SOURCE!"
213 fi
214
215 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
216 fi
217
218 case ${EPATCH_SUFFIX##*\.} in
219 bz2)
220 PIPE_CMD="bzip2 -dc"
221 PATCH_SUFFIX="bz2"
222 ;; 970 ;;
223 gz|Z|z) 971 *)
224 PIPE_CMD="gzip -dc" 972 eerror "${size} is an unsupported icon size!"
225 PATCH_SUFFIX="gz" 973 exit 1;;
226 ;; 974 esac
227 ZIP|zip) 975 shift 2;;
228 PIPE_CMD="unzip -p" 976 -t|--theme)
229 PATCH_SUFFIX="zip" 977 theme=${2}
230 ;; 978 shift 2;;
979 -c|--context)
980 context=${2}
981 shift 2;;
231 *) 982 *)
232 PIPE_CMD="cat" 983 if [[ -z ${size} ]] ; then
233 PATCH_SUFFIX="patch" 984 insinto /usr/share/pixmaps
234 ;; 985 else
235 esac 986 insinto /usr/share/icons/${theme}/${size}/${context}
236
237 if [ "${SINGLE_PATCH}" = "no" ]
238 then
239 einfo "Applying various patches (bugfixes/updates) ..."
240 fi
241 for x in ${EPATCH_SOURCE}
242 do
243 # New ARCH dependant patch naming scheme ...
244 #
245 # ???_arch_foo.patch
246 #
247 if [ -f ${x} ] && \
248 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \
249 [ "${EPATCH_FORCE}" = "yes" ])
250 then
251 local count=0
252 local popts="${EPATCH_OPTS}"
253
254 if [ -n "${EPATCH_EXCLUDE}" ]
255 then
256 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ]
257 then
258 continue
259 fi
260 fi 987 fi
261 988
262 if [ "${SINGLE_PATCH}" = "yes" ] 989 if [[ ${funcname} == doicon ]] ; then
263 then 990 if [[ -f $1 ]] ; then
264 if [ -n "${EPATCH_SINGLE_MSG}" ] 991 doins "${1}"
265 then 992 elif [[ -d $1 ]] ; then
266 einfo "${EPATCH_SINGLE_MSG}" 993 shopt -s nullglob
994 doins "${1}"/*.{png,svg}
995 shopt -u nullglob
267 else 996 else
268 einfo "Applying ${x##*/} ..." 997 eerror "${1} is not a valid file/directory!"
998 exit 1
269 fi 999 fi
270 else 1000 else
271 einfo " ${x##*/} ..." 1001 break
272 fi 1002 fi
273 1003 shift 1;;
274 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1004 esac
275 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
276
277 # Allow for prefix to differ ... im lazy, so shoot me :/
278 while [ "${count}" -lt 5 ]
279 do
280 # Generate some useful debug info ...
281 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
282 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
283
284 if [ "${PATCH_SUFFIX}" != "patch" ]
285 then
286 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
287 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
288 else
289 PATCH_TARGET="${x}"
290 fi
291
292 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
293 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
294
295 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
296 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
297
298 if [ "${PATCH_SUFFIX}" != "patch" ]
299 then
300 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
301 then
302 echo
303 eerror "Could not extract patch!"
304 #die "Could not extract patch!"
305 count=5
306 break
307 fi
308 fi
309
310 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
311 then
312 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
313 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
314 echo "ACTUALLY APPLYING ${x##*/} ..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
315 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
316 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
317
318 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1
319
320 if [ "$?" -ne 0 ]
321 then
322 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
323 echo
324 eerror "A dry-run of patch command succeeded, but actually"
325 eerror "applying the patch failed!"
326 #die "Real world sux compared to the dreamworld!"
327 count=5
328 fi
329
330 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
331
332 break
333 fi
334
335 count=$((count + 1))
336 done
337
338 if [ "${PATCH_SUFFIX}" != "patch" ]
339 then
340 rm -f ${PATCH_TARGET}
341 fi
342
343 if [ "${count}" -eq 5 ]
344 then
345 echo
346 eerror "Failed Patch: ${x##*/}!"
347 eerror
348 eerror "Include in your bugreport the contents of:"
349 eerror
350 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
351 echo
352 die "Failed Patch: ${x##*/}!"
353 fi
354
355 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
356
357 eend 0
358 fi
359 done 1005 done
360 if [ "${SINGLE_PATCH}" = "no" ] 1006 if [[ ${funcname} == newicon ]] ; then
361 then 1007 newins "$@"
362 einfo "Done with patching"
363 fi
364}
365
366# This function return true if we are using the NPTL pthreads
367# implementation.
368#
369# <azarah@gentoo.org> (06 March 2003)
370#
371have_NPTL() {
372 cat > ${T}/test-nptl.c <<-"END"
373 #define _XOPEN_SOURCE
374 #include <unistd.h>
375 #include <stdio.h>
376
377 int main()
378 {
379 char buf[255];
380 char *str = buf;
381
382 confstr(_CS_GNU_LIBPTHREAD_VERSION, str, 255);
383 if (NULL != str) {
384 printf("%s\n", str);
385 if (NULL != strstr(str, "NPTL"))
386 return 0;
387 }
388
389 return 1;
390 }
391 END
392
393 einfon "Checking for _CS_GNU_LIBPTHREAD_VERSION support in glibc ..."
394 if gcc -o ${T}/nptl ${T}/test-nptl.c &> /dev/null
395 then
396 echo "yes"
397 einfon "Checking what PTHREADS implementation we have ..."
398 if ${T}/nptl
399 then
400 return 0
401 else
402 return 1
403 fi 1008 fi
404 else 1009 ) || die
405 echo "no"
406 fi
407
408 return 1
409} 1010}
410 1011
411# This function check how many cpu's are present, and then set 1012# @FUNCTION: doicon
412# -j in MAKEOPTS accordingly. 1013# @USAGE: [options] <icons>
1014# @DESCRIPTION:
1015# Install icon into the icon directory /usr/share/icons or into
1016# /usr/share/pixmaps if "--size" is not set.
1017# This is useful in conjunction with creating desktop/menu files.
413# 1018#
414# Thanks to nall <nall@gentoo.org> for this. 1019# @CODE
1020# options:
1021# -s, --size
1022# !!! must specify to install into /usr/share/icons/... !!!
1023# size of the icon, like 48 or 48x48
1024# supported icon sizes are:
1025# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1026# -c, --context
1027# defaults to "apps"
1028# -t, --theme
1029# defaults to "hicolor"
415# 1030#
416get_number_of_jobs() { 1031# icons: list of icons
417 local jobs=0
418
419 if [ ! -r /proc/cpuinfo ]
420 then
421 return 1
422 fi
423
424 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
425 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
426 then
427 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
428 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
429 ADMINPARAM="${ADMINPARAM/-j}"
430 fi
431
432 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
433
434 if [ "${ARCH}" = "amd64" -o "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
435 "${ARCH}" = "arm" -o "${ARCH}" = "mips" -o "${ARCH}" = "ia64" ]
436 then
437 # these archs will always have "[Pp]rocessor"
438 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
439
440 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
441 then
442 # sparc always has "ncpus active"
443 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
444
445 elif [ "${ARCH}" = "alpha" ]
446 then
447 # alpha has "cpus active", but only when compiled with SMP
448 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
449 then
450 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
451 else
452 jobs=2
453 fi
454
455 elif [ "${ARCH}" = "ppc" -o "${ARCH}" = "ppc64" ]
456 then
457 # ppc has "processor", but only when compiled with SMP
458 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ]
459 then
460 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
461 else
462 jobs=2
463 fi
464 elif [ "${ARCH}" = "s390" ]
465 then
466 # s390 has "# processors : "
467 jobs="$((`grep "^\# processors" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
468 else
469 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))"
470 die "Unknown ARCH -- ${ARCH}!"
471 fi
472
473 # Make sure the number is valid ...
474 if [ "${jobs}" -lt 1 ]
475 then
476 jobs=1
477 fi
478
479 if [ -n "${ADMINPARAM}" ]
480 then
481 if [ "${jobs}" -gt "${ADMINPARAM}" ]
482 then
483 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge ..."
484 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
485 else
486 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge ..."
487 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
488 fi
489 fi
490}
491
492# Cheap replacement for when debianutils (and thus mktemp)
493# does not exist on the users system
494# vapier@gentoo.org
495# 1032#
496# Takes just 1 optional parameter (the directory to create tmpfile in) 1033# example 1: doicon foobar.png fuqbar.svg suckbar.png
497emktemp() { 1034# results in: insinto /usr/share/pixmaps
498 local exe="touch" 1035# doins foobar.png fuqbar.svg suckbar.png
499 [ "$1" == "-d" ] && exe="mkdir" && shift
500 local topdir="$1"
501
502 if [ -z "${topdir}" ]
503 then
504 [ -z "${T}" ] \
505 && topdir="/tmp" \
506 || topdir="${T}"
507 fi
508
509 if [ -z "$(type -p mktemp)" ]
510 then
511 local tmp=/
512 while [ -e "${tmp}" ] ; do
513 tmp="${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}"
514 done
515 ${exe} "${tmp}"
516 echo "${tmp}"
517 else
518 [ "${exe}" == "touch" ] \
519 && exe="-p" \
520 || exe="-d"
521 mktemp ${exe} "${topdir}"
522 fi
523}
524
525# Small wrapper for getent (Linux), nidump (Mac OS X),
526# and pw (FreeBSD) used in enewuser()/enewgroup()
527# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
528# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
529# 1036#
530# egetent(database, key) 1037# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
531egetent() { 1038# results in: insinto /usr/share/icons/hicolor/48x48/apps
532 if useq ppc-macos ; then 1039# doins foobar.png fuqbar.png blobbar.png
533 case "$2" in 1040# @CODE
534 *[!0-9]*) # Non numeric
535 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
536 ;;
537 *) # Numeric
538 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
539 ;;
540 esac
541 elif useq x86-fbsd ; then
542 local action
543 if [ "$1" == "passwd" ]
544 then
545 action="user"
546 else
547 action="group"
548 fi
549 pw show "${action}" "$2" -q
550 else
551 which nscd >& /dev/null && nscd -i "$1"
552 getent "$1" "$2"
553 fi
554}
555
556# Simplify/standardize adding users to the system
557# vapier@gentoo.org
558#
559# enewuser(username, uid, shell, homedir, groups, extra options)
560#
561# Default values if you do not specify any:
562# username: REQUIRED !
563# uid: next available (see useradd(8))
564# note: pass -1 to get default behavior
565# shell: /bin/false
566# homedir: /dev/null
567# groups: none
568# extra: comment of 'added by portage for ${PN}'
569enewuser() {
570 # get the username
571 local euser="$1"; shift
572 if [ -z "${euser}" ]
573 then
574 eerror "No username specified !"
575 die "Cannot call enewuser without a username"
576 fi
577
578 # lets see if the username already exists
579 if [ "${euser}" == "`egetent passwd \"${euser}\" | cut -d: -f1`" ]
580 then
581 return 0
582 fi
583 einfo "Adding user '${euser}' to your system ..."
584
585 # options to pass to useradd
586 local opts=
587
588 # handle uid
589 local euid="$1"; shift
590 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ]
591 then
592 if [ "${euid}" -gt 0 ]
593 then
594 if [ ! -z "`egetent passwd ${euid}`" ]
595 then
596 euid="next"
597 fi
598 else
599 eerror "Userid given but is not greater than 0 !"
600 die "${euid} is not a valid UID"
601 fi
602 else
603 euid="next"
604 fi
605 if [ "${euid}" == "next" ]
606 then
607 local pwrange
608 if [ "${USERLAND}" == "BSD" ] ; then
609 pwrange="`jot 898 101`"
610 else
611 pwrange="`seq 101 999`"
612 fi
613 for euid in ${pwrange} ; do
614 [ -z "`egetent passwd ${euid}`" ] && break
615 done
616 fi
617 opts="${opts} -u ${euid}"
618 einfo " - Userid: ${euid}"
619
620 # handle shell
621 local eshell="$1"; shift
622 if [ ! -z "${eshell}" ] && [ "${eshell}" != "-1" ]
623 then
624 if [ ! -e "${eshell}" ]
625 then
626 eerror "A shell was specified but it does not exist !"
627 die "${eshell} does not exist"
628 fi
629 else
630 if [ "${USERLAND}" == "BSD" ]
631 then
632 eshell="/usr/bin/false"
633 else
634 eshell="/bin/false"
635 fi
636 fi
637 einfo " - Shell: ${eshell}"
638 opts="${opts} -s ${eshell}"
639
640 # handle homedir
641 local ehome="$1"; shift
642 if [ -z "${ehome}" ] && [ "${eshell}" != "-1" ]
643 then
644 ehome="/dev/null"
645 fi
646 einfo " - Home: ${ehome}"
647 opts="${opts} -d ${ehome}"
648
649 # handle groups
650 local egroups="$1"; shift
651 if [ ! -z "${egroups}" ]
652 then
653 local oldifs="${IFS}"
654 local defgroup="" exgroups=""
655
656 export IFS=","
657 for g in ${egroups}
658 do
659 export IFS="${oldifs}"
660 if [ -z "`egetent group \"${g}\"`" ]
661 then
662 eerror "You must add group ${g} to the system first"
663 die "${g} is not a valid GID"
664 fi
665 if [ -z "${defgroup}" ]
666 then
667 defgroup="${g}"
668 else
669 exgroups="${exgroups},${g}"
670 fi
671 export IFS=","
672 done
673 export IFS="${oldifs}"
674
675 opts="${opts} -g ${defgroup}"
676 if [ ! -z "${exgroups}" ]
677 then
678 opts="${opts} -G ${exgroups:1}"
679 fi
680 else
681 egroups="(none)"
682 fi
683 einfo " - Groups: ${egroups}"
684
685 # handle extra and add the user
686 local eextra="$@"
687 local oldsandbox="${SANDBOX_ON}"
688 export SANDBOX_ON="0"
689 if useq ppc-macos
690 then
691 ### Make the user
692 if [ -z "${eextra}" ]
693 then
694 dscl . create /users/${euser} uid ${euid}
695 dscl . create /users/${euser} shell ${eshell}
696 dscl . create /users/${euser} home ${ehome}
697 dscl . create /users/${euser} realname "added by portage for ${PN}"
698 ### Add the user to the groups specified
699 local oldifs="${IFS}"
700 export IFS=","
701 for g in ${egroups}
702 do
703 dscl . merge /groups/${g} users ${euser}
704 done
705 export IFS="${oldifs}"
706 else
707 einfo "Extra options are not supported on macos yet"
708 einfo "Please report the ebuild along with the info below"
709 einfo "eextra: ${eextra}"
710 die "Required function missing"
711 fi
712 elif use x86-fbsd ; then
713 if [ -z "${eextra}" ]
714 then
715 pw useradd ${euser} ${opts} \
716 -c "added by portage for ${PN}" \
717 die "enewuser failed"
718 else
719 einfo " - Extra: ${eextra}"
720 pw useradd ${euser} ${opts} \
721 -c ${eextra} || die "enewuser failed"
722 fi
723 else
724 if [ -z "${eextra}" ]
725 then
726 useradd ${opts} ${euser} \
727 -c "added by portage for ${PN}" \
728 || die "enewuser failed"
729 else
730 einfo " - Extra: ${eextra}"
731 useradd ${opts} ${euser} ${eextra} \
732 || die "enewuser failed"
733 fi
734 fi
735 export SANDBOX_ON="${oldsandbox}"
736
737 if [ ! -e "${ehome}" ] && [ ! -e "${D}/${ehome}" ]
738 then
739 einfo " - Creating ${ehome} in ${D}"
740 dodir ${ehome}
741 fowners ${euser} ${ehome}
742 fperms 755 ${ehome}
743 fi
744}
745
746# Simplify/standardize adding groups to the system
747# vapier@gentoo.org
748#
749# enewgroup(group, gid)
750#
751# Default values if you do not specify any:
752# groupname: REQUIRED !
753# gid: next available (see groupadd(8))
754# extra: none
755enewgroup() {
756 # get the group
757 local egroup="$1"; shift
758 if [ -z "${egroup}" ]
759 then
760 eerror "No group specified !"
761 die "Cannot call enewgroup without a group"
762 fi
763
764 # see if group already exists
765 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
766 then
767 return 0
768 fi
769 einfo "Adding group '${egroup}' to your system ..."
770
771 # options to pass to useradd
772 local opts=
773
774 # handle gid
775 local egid="$1"; shift
776 if [ ! -z "${egid}" ]
777 then
778 if [ "${egid}" -gt 0 ]
779 then
780 if [ -z "`egetent group ${egid}`" ]
781 then
782 if useq ppc-macos ; then
783 opts="${opts} ${egid}"
784 else
785 opts="${opts} -g ${egid}"
786 fi
787 else
788 egid="next available; requested gid taken"
789 fi
790 else
791 eerror "Groupid given but is not greater than 0 !"
792 die "${egid} is not a valid GID"
793 fi
794 else
795 egid="next available"
796 fi
797 einfo " - Groupid: ${egid}"
798
799 # handle extra
800 local eextra="$@"
801 opts="${opts} ${eextra}"
802
803 # add the group
804 local oldsandbox="${SANDBOX_ON}"
805 export SANDBOX_ON="0"
806 if useq ppc-macos ; then
807 if [ ! -z "${eextra}" ];
808 then
809 einfo "Extra options are not supported on macos yet"
810 einfo "Please report the ebuild along with the info below"
811 einfo "eextra: ${eextra}"
812 die "Required function missing"
813 fi
814
815 # If we need the next available
816 case ${egid} in
817 *[!0-9]*) # Non numeric
818 for egid in `jot 898 101`; do
819 [ -z "`egetent group ${egid}`" ] && break
820 done
821 esac
822 dscl . create /groups/${egroup} gid ${egid}
823 dscl . create /groups/${egroup} passwd '*'
824 elif use x86-fbsd ; then
825 case ${egid} in
826 *[!0-9]*) # Non numeric
827 for egid in `jot 898 101`; do
828 [ -z "`egetent group ${egid}`" ] && break
829 done
830 esac
831 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
832 else
833 groupadd ${opts} ${egroup} || die "enewgroup failed"
834 fi
835 export SANDBOX_ON="${oldsandbox}"
836}
837
838# Simple script to replace 'dos2unix' binaries
839# vapier@gentoo.org
840#
841# edos2unix(file, <more files> ...)
842edos2unix() {
843 for f in "$@"
844 do
845 cp "${f}" ${T}/edos2unix
846 sed 's/\r$//' ${T}/edos2unix > "${f}"
847 done
848}
849
850
851##############################################################
852# START: Handle .desktop files and menu entries #
853# maybe this should be separated into a new eclass some time #
854# lanius@gentoo.org #
855##############################################################
856
857# Make a desktop file !
858# Great for making those icons in kde/gnome startmenu !
859# Amaze your friends ! Get the women ! Join today !
860#
861# make_desktop_entry(<binary>, [name], [icon], [type], [path])
862#
863# binary: what binary does the app run with ?
864# name: the name that will show up in the menu
865# icon: give your little like a pretty little icon ...
866# this can be relative (to /usr/share/pixmaps) or
867# a full path to an icon
868# type: what kind of application is this ? for categories:
869# http://www.freedesktop.org/standards/menu-spec/
870# path: if your app needs to startup in a specific dir
871make_desktop_entry() {
872 [ -z "$1" ] && eerror "make_desktop_entry: You must specify the executable" && return 1
873
874 local exec="${1}"
875 local name="${2:-${PN}}"
876 local icon="${3:-${PN}.png}"
877 local type="${4}"
878 local subdir="${6}"
879 local path="${5:-${GAMES_BINDIR}}"
880 if [ -z "${type}" ]
881 then
882 case ${CATEGORY} in
883 "app-emulation")
884 type=Emulator
885 subdir="Emulation"
886 ;;
887 "games-"*)
888 type=Game
889 subdir="Games"
890 ;;
891 "net-"*)
892 type=Network
893 subdir="${type}"
894 ;;
895 *)
896 type=
897 subdir=
898 ;;
899 esac
900 fi
901 local desktop="${T}/${exec}.desktop"
902
903echo "[Desktop Entry]
904Encoding=UTF-8
905Version=0.9.2
906Name=${name}
907Type=Application
908Comment=${DESCRIPTION}
909Exec=${exec}
910Path=${path}
911Icon=${icon}
912Categories=Application;${type};" > "${desktop}"
913
914 insinto /usr/share/applications
915 doins "${desktop}"
916
917 return 0
918}
919
920# Make a GDM/KDM Session file
921#
922# make_desktop_entry(<title>, <command>)
923# title: File to execute to start the Window Manager
924# command: Name of the Window Manager
925
926make_session_desktop() {
927
928 [ -z "$1" ] && eerror "make_session_desktop: You must specify the title" && return 1
929 [ -z "$2" ] && eerror "make_session_desktop: You must specify the command" && return 1
930
931 local title="${1}"
932 local command="${2}"
933 local desktop="${T}/${wm}.desktop"
934
935echo "[Desktop Entry]
936Encoding=UTF-8
937Name=${title}
938Comment=This session logs you into ${title}
939Exec=${command}
940TryExec=${command}
941Type=Application" > "${desktop}"
942
943 insinto /usr/share/xsessions
944 doins "${desktop}"
945
946 return 0
947}
948
949domenu() {
950 local i
951 local j
952 insinto /usr/share/applications
953 for i in ${@}
954 do
955 if [ -f "${i}" ];
956 then
957 doins ${i}
958 elif [ -d "${i}" ];
959 then
960 for j in ${i}/*.desktop
961 do
962 doins ${j}
963 done
964 fi
965 done
966}
967
968doicon() { 1041doicon() {
969 local i 1042 _iconins ${FUNCNAME} "$@"
970 local j 1043}
1044
1045# @FUNCTION: newicon
1046# @USAGE: [options] <icon> <newname>
1047# @DESCRIPTION:
1048# Like doicon, install the specified icon as newname.
1049#
1050# @CODE
1051# example 1: newicon foobar.png NEWNAME.png
971 insinto /usr/share/pixmaps 1052# results in: insinto /usr/share/pixmaps
972 for i in ${@} 1053# newins foobar.png NEWNAME.png
973 do
974 if [ -f "${i}" ];
975 then
976 doins ${i}
977 elif [ -d "${i}" ];
978 then
979 for j in ${i}/*.png
980 do
981 doins ${j}
982 done
983 fi
984 done
985}
986
987##############################################################
988# END: Handle .desktop files and menu entries #
989##############################################################
990
991
992# for internal use only (unpack_pdv and unpack_makeself)
993find_unpackable_file() {
994 local src="$1"
995 if [ -z "${src}" ]
996 then
997 src="${DISTDIR}/${A}"
998 else
999 if [ -e "${DISTDIR}/${src}" ]
1000 then
1001 src="${DISTDIR}/${src}"
1002 elif [ -e "${PWD}/${src}" ]
1003 then
1004 src="${PWD}/${src}"
1005 elif [ -e "${src}" ]
1006 then
1007 src="${src}"
1008 fi
1009 fi
1010 [ ! -e "${src}" ] && die "Could not find requested archive ${src}"
1011 echo "${src}"
1012}
1013
1014# Unpack those pesky pdv generated files ...
1015# They're self-unpacking programs with the binary package stuffed in
1016# the middle of the archive. Valve seems to use it a lot ... too bad
1017# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1018# 1054#
1019# Usage: unpack_pdv [file to unpack] [size of off_t] 1055# example 2: newicon -s 48 foobar.png NEWNAME.png
1020# - you have to specify the off_t size ... i have no idea how to extract that 1056# results in: insinto /usr/share/icons/hicolor/48x48/apps
1021# information out of the binary executable myself. basically you pass in 1057# newins foobar.png NEWNAME.png
1022# the size of the off_t type (in bytes) on the machine that built the pdv 1058# @CODE
1023# archive. one way to determine this is by running the following commands: 1059newicon() {
1024# strings <pdv archive> | grep lseek 1060 _iconins ${FUNCNAME} "$@"
1025# strace -elseek <pdv archive>
1026# basically look for the first lseek command (we do the strings/grep because
1027# sometimes the function call is _llseek or something) and steal the 2nd
1028# parameter. here is an example:
1029# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1030# lseek
1031# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1032# lseek(3, -4, SEEK_END) = 2981250
1033# thus we would pass in the value of '4' as the second parameter.
1034unpack_pdv() {
1035 local src="`find_unpackable_file $1`"
1036 local sizeoff_t="$2"
1037
1038 [ -z "${sizeoff_t}" ] && die "No idea what off_t size was used for this pdv :("
1039
1040 local shrtsrc="`basename ${src}`"
1041 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1042 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
1043 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
1044
1045 # grab metadata for debug reasons
1046 local metafile="$(emktemp)"
1047 tail -c +$((${metaskip}+1)) ${src} > ${metafile}
1048
1049 # rip out the final file name from the metadata
1050 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`"
1051 datafile="`basename ${datafile}`"
1052
1053 # now lets uncompress/untar the file if need be
1054 local tmpfile="$(emktemp)"
1055 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1056
1057 local iscompressed="`file -b ${tmpfile}`"
1058 if [ "${iscompressed:0:8}" == "compress" ] ; then
1059 iscompressed=1
1060 mv ${tmpfile}{,.Z}
1061 gunzip ${tmpfile}
1062 else
1063 iscompressed=0
1064 fi
1065 local istar="`file -b ${tmpfile}`"
1066 if [ "${istar:0:9}" == "POSIX tar" ] ; then
1067 istar=1
1068 else
1069 istar=0
1070 fi
1071
1072 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1073 #dd if=${src} ibs=${metaskip} count=1 \
1074 # | dd ibs=${tailskip} skip=1 \
1075 # | gzip -dc \
1076 # > ${datafile}
1077 if [ ${iscompressed} -eq 1 ] ; then
1078 if [ ${istar} -eq 1 ] ; then
1079 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1080 | head -c $((${metaskip}-${tailskip})) \
1081 | tar -xzf -
1082 else
1083 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1084 | head -c $((${metaskip}-${tailskip})) \
1085 | gzip -dc \
1086 > ${datafile}
1087 fi
1088 else
1089 if [ ${istar} -eq 1 ] ; then
1090 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1091 | head -c $((${metaskip}-${tailskip})) \
1092 | tar --no-same-owner -xf -
1093 else
1094 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1095 | head -c $((${metaskip}-${tailskip})) \
1096 > ${datafile}
1097 fi
1098 fi
1099 true
1100 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1101 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1102} 1061}
1103 1062
1104# Unpack those pesky makeself generated files ... 1063# @FUNCTION: strip-linguas
1105# They're shell scripts with the binary package tagged onto 1064# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1106# the end of the archive. Loki utilized the format as does 1065# @DESCRIPTION:
1107# many other game companies.
1108#
1109# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1110# - If the file is not specified then unpack will utilize ${A}.
1111# - If the offset is not specified then we will attempt to extract
1112# the proper offset from the script itself.
1113unpack_makeself() {
1114 local src="$(find_unpackable_file "$1")"
1115 local skip="$2"
1116 local exe="$3"
1117
1118 local shrtsrc="$(basename "${src}")"
1119 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1120 if [ -z "${skip}" ]
1121 then
1122 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`"
1123 local skip=0
1124 exe=tail
1125 case ${ver} in
1126 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1127 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1128 ;;
1129 2.0|2.0.1)
1130 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1131 ;;
1132 2.1.1)
1133 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1134 let skip="skip + 1"
1135 ;;
1136 2.1.2)
1137 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1138 let skip="skip + 1"
1139 ;;
1140 2.1.3)
1141 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1142 let skip="skip + 1"
1143 ;;
1144 2.1.4)
1145 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1146 skip=$(head -n ${skip} "${src}" | wc -c)
1147 exe="dd"
1148 ;;
1149 *)
1150 eerror "I'm sorry, but I was unable to support the Makeself file."
1151 eerror "The version I detected was '${ver}'."
1152 eerror "Please file a bug about the file ${shrtsrc} at"
1153 eerror "http://bugs.gentoo.org/ so that support can be added."
1154 die "makeself version '${ver}' not supported"
1155 ;;
1156 esac
1157 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1158 fi
1159 case ${exe} in
1160 tail) exe="tail -n +${skip} '${src}'";;
1161 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";;
1162 *) die "makeself cant handle exe '${exe}'"
1163 esac
1164
1165 # lets grab the first few bytes of the file to figure out what kind of archive it is
1166 local tmpfile="$(emktemp)"
1167 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1168 local filetype="$(file -b "${tmpfile}")"
1169 case ${filetype} in
1170 *tar\ archive)
1171 eval ${exe} | tar --no-same-owner -xf -
1172 ;;
1173 bzip2*)
1174 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1175 ;;
1176 gzip*)
1177 eval ${exe} | tar --no-same-owner -xzf -
1178 ;;
1179 compress*)
1180 eval ${exe} | gunzip | tar --no-same-owner -xf -
1181 ;;
1182 *)
1183 eerror "Unknown filetype \"${filetype}\" ?"
1184 false
1185 ;;
1186 esac
1187 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1188}
1189
1190# Display a license for user to accept.
1191#
1192# Usage: check_license [license]
1193# - If the file is not specified then ${LICENSE} is used.
1194check_license() {
1195 local lic=$1
1196 if [ -z "${lic}" ] ; then
1197 lic="${PORTDIR}/licenses/${LICENSE}"
1198 else
1199 if [ -e "${PORTDIR}/licenses/${src}" ] ; then
1200 lic="${PORTDIR}/licenses/${src}"
1201 elif [ -e "${PWD}/${src}" ] ; then
1202 lic="${PWD}/${src}"
1203 elif [ -e "${src}" ] ; then
1204 lic="${src}"
1205 fi
1206 fi
1207 [ ! -f "${lic}" ] && die "Could not find requested license ${src}"
1208 local l="`basename ${lic}`"
1209
1210 # here is where we check for the licenses the user already
1211 # accepted ... if we don't find a match, we make the user accept
1212 local shopts=$-
1213 local alic
1214 set -o noglob #so that bash doesn't expand "*"
1215 for alic in ${ACCEPT_LICENSE} ; do
1216 if [[ ${alic} == * || ${alic} == ${l} ]]; then
1217 set +o noglob; set -${shopts} #reset old shell opts
1218 return 0
1219 fi
1220 done
1221 set +o noglob; set -$shopts #reset old shell opts
1222
1223 local licmsg="$(emktemp)"
1224 cat << EOF > ${licmsg}
1225**********************************************************
1226The following license outlines the terms of use of this
1227package. You MUST accept this license for installation to
1228continue. When you are done viewing, hit 'q'. If you
1229CTRL+C out of this, the install will not run!
1230**********************************************************
1231
1232EOF
1233 cat ${lic} >> ${licmsg}
1234 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1235 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1236 read alic
1237 case ${alic} in
1238 yes|Yes|y|Y)
1239 return 0
1240 ;;
1241 *)
1242 echo;echo;echo
1243 eerror "You MUST accept the license to continue! Exiting!"
1244 die "Failed to accept license"
1245 ;;
1246 esac
1247}
1248
1249# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1250# the whole 'non-interactive' policy, but damnit I want CD support !
1251#
1252# with these cdrom functions we handle all the user interaction and
1253# standardize everything. all you have to do is call cdrom_get_cds()
1254# and when the function returns, you can assume that the cd has been
1255# found at CDROM_ROOT.
1256#
1257# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1258# etc... if you want to give the cds better names, then just export
1259# the CDROM_NAME_X variables before calling cdrom_get_cds().
1260#
1261# for those multi cd ebuilds, see the cdrom_load_next_cd() below.
1262#
1263# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1264# - this will attempt to locate a cd based upon a file that is on
1265# the cd ... the more files you give this function, the more cds
1266# the cdrom functions will handle
1267cdrom_get_cds() {
1268 # first we figure out how many cds we're dealing with by
1269 # the # of files they gave us
1270 local cdcnt=0
1271 local f=
1272 for f in "$@" ; do
1273 cdcnt=$((cdcnt + 1))
1274 export CDROM_CHECK_${cdcnt}="$f"
1275 done
1276 export CDROM_TOTAL_CDS=${cdcnt}
1277 export CDROM_CURRENT_CD=1
1278
1279 # now we see if the user gave use CD_ROOT ...
1280 # if they did, let's just believe them that it's correct
1281 if [[ ! -z ${CD_ROOT} ]] ; then
1282 export CDROM_ROOT=${CD_ROOT}
1283 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1284 return
1285 fi
1286 # do the same for CD_ROOT_X
1287 if [[ ! -z ${CD_ROOT_1} ]] ; then
1288 local var=
1289 cdcnt=0
1290 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1291 cdcnt=$((cdcnt + 1))
1292 var="CD_ROOT_${cdcnt}"
1293 if [[ -z ${!var} ]] ; then
1294 eerror "You must either use just the CD_ROOT"
1295 eerror "or specify ALL the CD_ROOT_X variables."
1296 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1297 die "could not locate CD_ROOT_${cdcnt}"
1298 fi
1299 export CDROM_ROOTS_${cdcnt}="${!var}"
1300 done
1301 export CDROM_ROOT=${CDROM_ROOTS_1}
1302 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1303 return
1304 fi
1305
1306 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1307 einfon "This ebuild will need the "
1308 if [[ -z ${CDROM_NAME} ]] ; then
1309 echo "cdrom for ${PN}."
1310 else
1311 echo "${CDROM_NAME}."
1312 fi
1313 echo
1314 einfo "If you do not have the CD, but have the data files"
1315 einfo "mounted somewhere on your filesystem, just export"
1316 einfo "the variable CD_ROOT so that it points to the"
1317 einfo "directory containing the files."
1318 echo
1319 einfo "For example:"
1320 einfo "export CD_ROOT=/mnt/cdrom"
1321 echo
1322 else
1323 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1324 cdcnt=0
1325 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1326 cdcnt=$((cdcnt + 1))
1327 var="CDROM_NAME_${cdcnt}"
1328 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1329 done
1330 echo
1331 einfo "If you do not have the CDs, but have the data files"
1332 einfo "mounted somewhere on your filesystem, just export"
1333 einfo "the following variables so they point to the right place:"
1334 einfon ""
1335 cdcnt=0
1336 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1337 cdcnt=$((cdcnt + 1))
1338 echo -n " CD_ROOT_${cdcnt}"
1339 done
1340 echo
1341 einfo "Or, if you have all the files in the same place, or"
1342 einfo "you only have one cdrom, you can export CD_ROOT"
1343 einfo "and that place will be used as the same data source"
1344 einfo "for all the CDs."
1345 echo
1346 einfo "For example:"
1347 einfo "export CD_ROOT_1=/mnt/cdrom"
1348 echo
1349 fi
1350 export CDROM_CURRENT_CD=0
1351 cdrom_load_next_cd
1352}
1353
1354# this is only used when you need access to more than one cd.
1355# when you have finished using the first cd, just call this function.
1356# when it returns, CDROM_ROOT will be pointing to the second cd.
1357# remember, you can only go forward in the cd chain, you can't go back.
1358cdrom_load_next_cd() {
1359 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1))
1360 local var=
1361
1362 if [[ ! -z ${CD_ROOT} ]] ; then
1363 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}"
1364 return
1365 fi
1366
1367 unset CDROM_ROOT
1368 var=CDROM_ROOTS_${CDROM_CURRENT_CD}
1369 if [[ -z ${!var} ]] ; then
1370 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1371 cdrom_locate_file_on_cd ${!var}
1372 else
1373 export CDROM_ROOT=${!var}
1374 fi
1375
1376 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1377}
1378
1379# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1380# functions. this should *never* be called from an ebuild.
1381# all it does is try to locate a give file on a cd ... if the cd isn't
1382# found, then a message asking for the user to insert the cdrom will be
1383# displayed and we'll hang out here until:
1384# (1) the file is found on a mounted cdrom
1385# (2) the user hits CTRL+C
1386cdrom_locate_file_on_cd() {
1387 while [[ -z ${CDROM_ROOT} ]] ; do
1388 local dir="$(dirname ${@})"
1389 local file="$(basename ${@})"
1390 local mline=""
1391 local showedmsg=0
1392
1393 for mline in $(mount | egrep -e '(iso|cdrom)' | awk '{print $3}') ; do
1394 [[ -d ${mline}/${dir} ]] || continue
1395 [[ ! -z $(find ${mline}/${dir} -iname ${file} -maxdepth 1) ]] \
1396 && export CDROM_ROOT=${mline}
1397 done
1398
1399 if [[ -z ${CDROM_ROOT} ]] ; then
1400 echo
1401 if [[ ${showedmsg} -eq 0 ]] ; then
1402 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1403 if [[ -z ${CDROM_NAME} ]] ; then
1404 einfo "Please insert the cdrom for ${PN} now !"
1405 else
1406 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1407 fi
1408 else
1409 if [[ -z ${CDROM_NAME_1} ]] ; then
1410 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1411 else
1412 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1413 einfo "Please insert+mount the ${!var} cdrom now !"
1414 fi
1415 fi
1416 showedmsg=1
1417 fi
1418 einfo "Press return to scan for the cd again"
1419 einfo "or hit CTRL+C to abort the emerge."
1420 read
1421 fi
1422 done
1423}
1424
1425# Make sure that LINGUAS only contains languages that 1066# Make sure that LINGUAS only contains languages that
1426# a package can support 1067# a package can support. The first form allows you to
1427# 1068# specify a list of LINGUAS. The -i builds a list of po
1428# usage: strip-linguas <allow LINGUAS> 1069# files found in all the directories and uses the
1429# strip-linguas -i <directories of .po files> 1070# intersection of the lists. The -u builds a list of po
1430# strip-linguas -u <directories of .po files> 1071# files found in all the directories and uses the union
1431# 1072# of the lists.
1432# The first form allows you to specify a list of LINGUAS.
1433# The -i builds a list of po files found in all the
1434# directories and uses the intersection of the lists.
1435# The -u builds a list of po files found in all the
1436# directories and uses the union of the lists.
1437strip-linguas() { 1073strip-linguas() {
1438 local ls newls 1074 local ls newls nols
1439 if [ "$1" == "-i" ] || [ "$1" == "-u" ] ; then 1075 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1440 local op="$1"; shift 1076 local op=$1; shift
1441 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1077 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1442 local d f 1078 local d f
1443 for d in "$@" ; do 1079 for d in "$@" ; do
1444 if [ "${op}" == "-u" ] ; then 1080 if [[ ${op} == "-u" ]] ; then
1445 newls="${ls}" 1081 newls=${ls}
1446 else 1082 else
1447 newls="" 1083 newls=""
1448 fi 1084 fi
1449 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1085 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1450 if [ "${op}" == "-i" ] ; then 1086 if [[ ${op} == "-i" ]] ; then
1451 [ "${ls/ ${f} /}" != "${ls}" ] && newls="${newls} ${f}" 1087 has ${f} ${ls} && newls="${newls} ${f}"
1452 else 1088 else
1453 [ "${ls/ ${f} /}" == "${ls}" ] && newls="${newls} ${f}" 1089 has ${f} ${ls} || newls="${newls} ${f}"
1454 fi 1090 fi
1455 done 1091 done
1456 ls="${newls}" 1092 ls=${newls}
1457 done 1093 done
1458 ls="${ls//.po}"
1459 else 1094 else
1460 ls="$@" 1095 ls="$@"
1461 fi 1096 fi
1462 1097
1463 ls=" ${ls} " 1098 nols=""
1464 newls="" 1099 newls=""
1465 for f in ${LINGUAS} ; do 1100 for f in ${LINGUAS} ; do
1466 if [ "${ls/ ${f} /}" != "${ls}" ] ; then 1101 if has ${f} ${ls} ; then
1467 newls="${newls} ${f}" 1102 newls="${newls} ${f}"
1468 else 1103 else
1469 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1104 nols="${nols} ${f}"
1470 fi 1105 fi
1471 done 1106 done
1472 if [ -z "${newls}" ] ; then 1107 [[ -n ${nols} ]] \
1473 unset LINGUAS 1108 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1474 else
1475 export LINGUAS="${newls}" 1109 export LINGUAS=${newls:1}
1476 fi
1477} 1110}
1478 1111
1479# moved from kernel.eclass since they are generally useful outside of 1112# @FUNCTION: preserve_old_lib
1480# kernel.eclass -iggy (20041002) 1113# @USAGE: <libs to preserve> [more libs]
1481 1114# @DESCRIPTION:
1482# the following functions are useful in kernel module ebuilds, etc.
1483# for an example see ivtv or drbd ebuilds
1484
1485# set's ARCH to match what the kernel expects
1486set_arch_to_kernel() {
1487 i=10
1488 while ((i--)) ; do
1489 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1490 done
1491 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1492 case ${ARCH} in
1493 x86) export ARCH="i386";;
1494 amd64) export ARCH="x86_64";;
1495 hppa) export ARCH="parisc";;
1496 mips) export ARCH="mips";;
1497 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1498 *) export ARCH="${ARCH}";;
1499 esac
1500}
1501
1502# set's ARCH back to what portage expects
1503set_arch_to_portage() {
1504 i=10
1505 while ((i--)) ; do
1506 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1507 done
1508 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1509}
1510
1511# Jeremy Huddleston <eradicator@gentoo.org>:
1512# preserve_old_lib /path/to/libblah.so.0
1513# preserve_old_lib_notify /path/to/libblah.so.0
1514#
1515# These functions are useful when a lib in your package changes --soname. Such 1115# These functions are useful when a lib in your package changes ABI SONAME.
1516# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1116# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1517# would break packages that link against it. Most people get around this 1117# would break packages that link against it. Most people get around this
1518# by using the portage SLOT mechanism, but that is not always a relevant 1118# by using the portage SLOT mechanism, but that is not always a relevant
1519# solution, so instead you can add the following to your ebuilds: 1119# solution, so instead you can call this from pkg_preinst. See also the
1520# 1120# preserve_old_lib_notify function.
1521# src_install() {
1522# ...
1523# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1524# ...
1525# }
1526#
1527# pkg_postinst() {
1528# ...
1529# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1530# ...
1531# }
1532
1533preserve_old_lib() { 1121preserve_old_lib() {
1534 LIB=$1 1122 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1123 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1124 die "Invalid preserve_old_lib() usage"
1125 fi
1126 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1535 1127
1536 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1128 # let portage worry about it
1537 SONAME=`basename ${LIB}` 1129 has preserve-libs ${FEATURES} && return 0
1538 DIRNAME=`dirname ${LIB}`
1539 1130
1540 dodir ${DIRNAME} 1131 local lib dir
1541 cp ${ROOT}${LIB} ${D}${DIRNAME} 1132 for lib in "$@" ; do
1133 [[ -e ${ROOT}/${lib} ]] || continue
1134 dir=${lib%/*}
1135 dodir ${dir} || die "dodir ${dir} failed"
1136 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1542 touch ${D}${LIB} 1137 touch "${D}"/${lib}
1543 fi 1138 done
1544} 1139}
1545 1140
1141# @FUNCTION: preserve_old_lib_notify
1142# @USAGE: <libs to notify> [more libs]
1143# @DESCRIPTION:
1144# Spit helpful messages about the libraries preserved by preserve_old_lib.
1546preserve_old_lib_notify() { 1145preserve_old_lib_notify() {
1547 LIB=$1 1146 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1147 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1148 die "Invalid preserve_old_lib_notify() usage"
1149 fi
1548 1150
1549 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1151 # let portage worry about it
1550 SONAME=`basename ${LIB}` 1152 has preserve-libs ${FEATURES} && return 0
1551 1153
1154 local lib notice=0
1155 for lib in "$@" ; do
1156 [[ -e ${ROOT}/${lib} ]] || continue
1157 if [[ ${notice} -eq 0 ]] ; then
1158 notice=1
1552 einfo "An old version of an installed library was detected on your system." 1159 ewarn "Old versions of installed libraries were detected on your system."
1553 einfo "In order to avoid breaking packages that link against is, this older version" 1160 ewarn "In order to avoid breaking packages that depend on these old libs,"
1554 einfo "is not being removed. In order to make full use of this newer version," 1161 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1555 einfo "you will need to execute the following command:" 1162 ewarn "in order to remove these old dependencies. If you do not have this"
1556 einfo " revdep-rebuild --soname ${SONAME}" 1163 ewarn "helper program, simply emerge the 'gentoolkit' package."
1557 einfo 1164 ewarn
1558 einfo "After doing that, you can safely remove ${LIB}"
1559 einfo "Note: 'emerge gentoolkit' to get revdep-rebuild"
1560 fi 1165 fi
1166 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1167 done
1561} 1168}
1562 1169
1563# Hack for people to figure out if a package was built with 1170# @FUNCTION: built_with_use
1564# certain USE flags 1171# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1172# @DESCRIPTION:
1565# 1173#
1566# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1174# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1567# ex: built_with_use xchat gtk2
1568# 1175#
1569# Flags: -a all USE flags should be utilized 1176# A temporary hack until portage properly supports DEPENDing on USE
1570# -o at least one USE flag should be utilized 1177# flags being enabled in packages. This will check to see if the specified
1571# Note: the default flag is '-a' 1178# DEPEND atom was built with the specified list of USE flags. The
1179# --missing option controls the behavior if called on a package that does
1180# not actually support the defined USE flags (aka listed in IUSE).
1181# The default is to abort (call die). The -a and -o flags control
1182# the requirements of the USE flags. They correspond to "and" and "or"
1183# logic. So the -a flag means all listed USE flags must be enabled
1184# while the -o flag means at least one of the listed IUSE flags must be
1185# enabled. The --hidden option is really for internal use only as it
1186# means the USE flag we're checking is hidden expanded, so it won't be found
1187# in IUSE like normal USE flags.
1188#
1189# Remember that this function isn't terribly intelligent so order of optional
1190# flags matter.
1572built_with_use() { 1191built_with_use() {
1192 local hidden="no"
1193 if [[ $1 == "--hidden" ]] ; then
1194 hidden="yes"
1195 shift
1196 fi
1197
1198 local missing_action="die"
1199 if [[ $1 == "--missing" ]] ; then
1200 missing_action=$2
1201 shift ; shift
1202 case ${missing_action} in
1203 true|false|die) ;;
1204 *) die "unknown action '${missing_action}'";;
1205 esac
1206 fi
1207
1573 local opt=$1 1208 local opt=$1
1574 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1209 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1575 1210
1576 local PKG=$(best_version $1) 1211 local PKG=$(best_version $1)
1212 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1577 shift 1213 shift
1578 1214
1579 local USEFILE="${ROOT}/var/db/pkg/${PKG}/USE" 1215 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1580 [[ ! -e ${USEFILE} ]] && return 1 1216 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1217
1218 # if the IUSE file doesn't exist, the read will error out, we need to handle
1219 # this gracefully
1220 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1221 case ${missing_action} in
1222 true) return 0;;
1223 false) return 1;;
1224 die) die "Unable to determine what USE flags $PKG was built with";;
1225 esac
1226 fi
1227
1228 if [[ ${hidden} == "no" ]] ; then
1229 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1230 # Don't check USE_EXPAND #147237
1231 local expand
1232 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1233 if [[ $1 == ${expand}_* ]] ; then
1234 expand=""
1235 break
1236 fi
1237 done
1238 if [[ -n ${expand} ]] ; then
1239 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1240 case ${missing_action} in
1241 true) return 0;;
1242 false) return 1;;
1243 die) die "$PKG does not actually support the $1 USE flag!";;
1244 esac
1245 fi
1246 fi
1247 fi
1581 1248
1582 local USE_BUILT=$(<${USEFILE}) 1249 local USE_BUILT=$(<${USEFILE})
1583 while [[ $# -gt 0 ]] ; do 1250 while [[ $# -gt 0 ]] ; do
1584 if [[ ${opt} = "-o" ]] ; then 1251 if [[ ${opt} = "-o" ]] ; then
1585 has $1 ${USE_BUILT} && return 0 1252 has $1 ${USE_BUILT} && return 0
1589 shift 1256 shift
1590 done 1257 done
1591 [[ ${opt} = "-a" ]] 1258 [[ ${opt} = "-a" ]]
1592} 1259}
1593 1260
1261# @FUNCTION: epunt_cxx
1262# @USAGE: [dir to scan]
1263# @DESCRIPTION:
1594# Many configure scripts wrongly bail when a C++ compiler 1264# Many configure scripts wrongly bail when a C++ compiler could not be
1595# could not be detected. #73450 1265# detected. If dir is not specified, then it defaults to ${S}.
1266#
1267# http://bugs.gentoo.org/73450
1596epunt_cxx() { 1268epunt_cxx() {
1597 local dir=$1 1269 local dir=$1
1598 [[ -z ${dir} ]] && dir=${S} 1270 [[ -z ${dir} ]] && dir=${S}
1599 ebegin "Removing useless C++ checks" 1271 ebegin "Removing useless C++ checks"
1600 local f 1272 local f
1601 for f in $(find ${dir} -name configure) ; do 1273 find "${dir}" -name configure | while read f ; do
1602 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1274 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1603 done 1275 done
1604 eend 0 1276 eend 0
1605} 1277}
1606 1278
1607# dopamd [ file ] [ new file ] 1279# @FUNCTION: make_wrapper
1608# 1280# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1609# Install pam auth config file in /etc/pam.d 1281# @DESCRIPTION:
1610# 1282# Create a shell wrapper script named wrapper in installpath
1611# The first argument, 'file' is required. Install as 'new file', if 1283# (defaults to the bindir) to execute target (default of wrapper) by
1612# specified. 1284# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1613 1285# libpaths followed by optionally changing directory to chdir.
1614dopamd() { 1286make_wrapper() {
1615 local pamd="$1" newpamd="${2:-$1}" 1287 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1616 [[ -z "$1" ]] && die "dopamd requires at least one argument." 1288 local tmpwrapper=$(emktemp)
1617 1289 # We don't want to quote ${bin} so that people can pass complex
1618 use pam || return 0 1290 # things as $bin ... "./someprog --args"
1619 1291 cat << EOF > "${tmpwrapper}"
1620 insinto /etc/pam.d 1292#!/bin/sh
1621 # these are the default doins options, but be explicit just in case 1293cd "${chdir:-.}"
1622 insopts -m 0644 -o root -g root 1294if [ -n "${libdir}" ] ; then
1623 newins ${pamd} ${newpamd} || die "failed to install ${newpamd}" 1295 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1296 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1297 else
1298 export LD_LIBRARY_PATH="${libdir}"
1299 fi
1300fi
1301exec ${bin} "\$@"
1302EOF
1303 chmod go+rx "${tmpwrapper}"
1304 if [[ -n ${path} ]] ; then
1305 (
1306 exeinto "${path}"
1307 newexe "${tmpwrapper}" "${wrapper}"
1308 ) || die
1309 else
1310 newbin "${tmpwrapper}" "${wrapper}" || die
1311 fi
1624} 1312}
1313
1314# @FUNCTION: path_exists
1315# @USAGE: [-a|-o] <paths>
1316# @DESCRIPTION:
1317# Check if the specified paths exist. Works for all types of paths
1318# (files/dirs/etc...). The -a and -o flags control the requirements
1319# of the paths. They correspond to "and" and "or" logic. So the -a
1320# flag means all the paths must exist while the -o flag means at least
1321# one of the paths must exist. The default behavior is "and". If no
1322# paths are specified, then the return value is "false".
1323path_exists() {
1324 local opt=$1
1325 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1326
1327 # no paths -> return false
1328 # same behavior as: [[ -e "" ]]
1329 [[ $# -eq 0 ]] && return 1
1330
1331 local p r=0
1332 for p in "$@" ; do
1333 [[ -e ${p} ]]
1334 : $(( r += $? ))
1335 done
1336
1337 case ${opt} in
1338 -a) return $(( r != 0 )) ;;
1339 -o) return $(( r == $# )) ;;
1340 esac
1341}
1342
1343# @FUNCTION: in_iuse
1344# @USAGE: <flag>
1345# @DESCRIPTION:
1346# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1347# as necessary.
1348#
1349# Note that this function should not be used in the global scope.
1350in_iuse() {
1351 debug-print-function ${FUNCNAME} "${@}"
1352 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1353
1354 local flag=${1}
1355 local liuse=( ${IUSE} )
1356
1357 has "${flag}" "${liuse[@]#[+-]}"
1358}
1359
1360# @FUNCTION: use_if_iuse
1361# @USAGE: <flag>
1362# @DESCRIPTION:
1363# Return true if the given flag is in USE and IUSE.
1364#
1365# Note that this function should not be used in the global scope.
1366use_if_iuse() {
1367 in_iuse $1 || return 1
1368 use $1
1369}
1370
1371# @FUNCTION: usex
1372# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1373# @DESCRIPTION:
1374# Proxy to declare usex for package managers or EAPIs that do not provide it
1375# and use the package manager implementation when available (i.e. EAPI >= 5).
1376# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1377# otherwise echo [false output][false suffix] (defaults to "no").
1378if has "${EAPI:-0}" 0 1 2 3 4; then
1379 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1380fi
1381
1382# @FUNCTION: prune_libtool_files
1383# @USAGE: [--all]
1384# @DESCRIPTION:
1385# Locate unnecessary libtool files (.la) and libtool static archives
1386# (.a) and remove them from installation image.
1387#
1388# By default, .la files are removed whenever the static linkage can
1389# either be performed using pkg-config or doesn't introduce additional
1390# flags.
1391#
1392# If '--all' argument is passed, all .la files are removed. This is
1393# usually useful when the package installs plugins and does not use .la
1394# files for loading them.
1395#
1396# The .a files are only removed whenever corresponding .la files state
1397# that they should not be linked to, i.e. whenever these files
1398# correspond to plugins.
1399#
1400# Note: if your package installs both static libraries and .pc files,
1401# you need to add pkg-config to your DEPEND.
1402prune_libtool_files() {
1403 debug-print-function ${FUNCNAME} "$@"
1404
1405 local removing_all opt
1406 for opt; do
1407 case "${opt}" in
1408 --all)
1409 removing_all=1
1410 ;;
1411 *)
1412 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1413 esac
1414 done
1415
1416 local f
1417 while IFS= read -r -d '' f; do # for all .la files
1418 local archivefile=${f/%.la/.a}
1419
1420 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1421
1422 # Remove static libs we're not supposed to link against.
1423 if grep -q '^shouldnotlink=yes$' "${f}"; then
1424 if [[ -f ${archivefile} ]]; then
1425 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1426 rm -f "${archivefile}"
1427 fi
1428
1429 # The .la file may be used by a module loader, so avoid removing it
1430 # unless explicitly requested.
1431 [[ ${removing_all} ]] || continue
1432 fi
1433
1434 # Remove .la files when:
1435 # - user explicitly wants us to remove all .la files,
1436 # - respective static archive doesn't exist,
1437 # - they are covered by a .pc file already,
1438 # - they don't provide any new information (no libs & no flags).
1439 local reason pkgconfig_scanned
1440 if [[ ${removing_all} ]]; then
1441 reason='requested'
1442 elif [[ ! -f ${archivefile} ]]; then
1443 reason='no static archive'
1444 elif [[ ! $(sed -nre \
1445 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1446 "${f}") ]]; then
1447 reason='no libs & flags'
1448 else
1449 if [[ ! ${pkgconfig_scanned} ]]; then
1450 # Create a list of all .pc-covered libs.
1451 local pc_libs=()
1452 if [[ ! ${removing_all} ]]; then
1453 local f
1454 local tf=${T}/prune-lt-files.pc
1455 local pkgconf=$(tc-getPKG_CONFIG)
1456
1457 while IFS= read -r -d '' f; do # for all .pc files
1458 local arg
1459
1460 sed -e '/^Requires:/d' "${f}" > "${tf}"
1461 for arg in $("${pkgconf}" --libs "${tf}"); do
1462 [[ ${arg} == -l* ]] && pc_libs+=( lib${arg#-l}.la )
1463 done
1464 done < <(find "${D}" -type f -name '*.pc' -print0)
1465
1466 rm -f "${tf}"
1467 fi
1468
1469 pkgconfig_scanned=1
1470 fi
1471
1472 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1473 fi
1474
1475 if [[ ${reason} ]]; then
1476 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1477 rm -f "${f}"
1478 fi
1479 done < <(find "${D}" -type f -name '*.la' -print0)
1480}
1481
1482check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1483
1484fi

Legend:
Removed from v.1.143  
changed lines
  Added in v.1.405

  ViewVC Help
Powered by ViewVC 1.1.20